#ifndef _Events1_H
#define _Events1_H



#include "Iter.H"
#include "List.H"



template< class Arg1 >
class EventLink1
{
public:
	virtual void Forward( Arg1 ) = 0;
};



template< class T, class Arg1 >
class EventStub1 : public EventLink1< Arg1 >
{
public:
	EventStub1( T* obs, void( T::*fun )( Arg1 ) ) {
		_obs = obs; _fun = fun;
	}
	virtual void Forward( Arg1 a1 ) {
		( _obs->*_fun )( a1 );
	}
		
private:
	T* _obs;
	void ( T::*_fun )( Arg1 );
};



template< class Arg1 >
class StateChange1
{
public:
	virtual void Register( EventLink1< Arg1 >* link ) {
		evLinks->Append( link );
	}
	virtual void Unregister( EventLink1< Arg1 >* link ) {
		evLinks->Remove( link );
	}
	virtual void Announce( Arg1 a1 ) {
		Iter< EventLink1< Arg1 >* > iter( evLinks );
		while ( EventLink1< Arg1 >* evLink = iter() ) {
			evLink->Forward( a1 );
		}
	}
	StateChange1() {
		evLinks = new List< EventLink1< Arg1 >* >();
	}
	
private:
	List< EventLink1< Arg1 >* >* evLinks;
};



#endif

