#ifndef _VoidIter_H
#define _VoidIter_H

#include "bool.h"



	// the list and cons cell this iterator works with
	//
class VoidList;
class VoidCons;


	// robust iterator for VoidList
	//
class VoidIter
{
public:
		// just do it! give current item and advance to next
	void* operator()();

		// give current item and stay were you are!
	void* Item();

		// insert and remove operation for manipulating the list
	void Insert( void* );
	void Remove();
	void Remove( void* );

		// further retrieval functionality
	bool Contains( void* );

		// connects and disconnects to specific VoidLists
	void Connect( VoidList& );
	void Disconnect();

		// ctor and dtor
	VoidIter( VoidList& );
	~VoidIter();

private:
		// implementation: holds a cons cell in a VoidList
	VoidList* pList;
	VoidCons* pCons;
};





#endif // _VoidIter_H

