#include "VoidList.H"



class VoidCons
{
public:
	VoidCons* pNext;
	VoidCons* pPrevious;
	void* pObject;
	bool IsValid;
	int Count;
};



void* VoidList::Item( VoidCons* pThis )
{
	return NextValid( pThis )->pObject;
}


bool VoidList::IsEmpty()
{
	return pHead == pTail;
}


VoidCons* VoidList::Insert( VoidCons* pCons, void* pObject )
{
	VoidCons* pNext = NextValid( pCons );
	VoidCons* pPrevious = PreviousValid( pCons );

	Drop( pCons );

	pCons = new VoidCons;

	pCons->pPrevious = pPrevious;
	pCons->pNext = pNext;
	pCons->pObject = pObject;
	pCons->IsValid = true;
	pCons->Count = 0;

	pNext->pPrevious = pCons;

	if ( pPrevious == null ) pHead = pCons;
	else pPrevious->pNext = pCons;

	Take( pNext );
	return pNext;
}


VoidCons* VoidList::Remove( VoidCons* pCons )
{
	VoidCons* pNext = NextValid( pCons );
	if ( pNext == pTail ) return pTail;
	Drop( pCons );

	Take( pNext );
	pNext->IsValid = false;

	pCons = NextValid( pNext );
	if ( pNext == pHead ) pHead = pCons;
	Drop( pNext );

	Take( pCons );
	return pCons;
}


void VoidList::Prepend( void* pObject )
{
	VoidCons* pCons = Head();
	pCons = Insert( pCons, pObject );
	Drop( pCons );
}


void VoidList::Append( void* pObject )
{
	VoidCons* pCons = Tail();
	pCons = Insert( pCons, pObject );
	Drop( pCons );
}


void VoidList::Remove( void* pObject )
{
	VoidCons* pCons = Find( pObject );
	pCons = Remove( pCons );
	Drop( pCons );
}


VoidCons* VoidList::Head()
{
	Take( pHead );
	return pHead;
}


VoidCons* VoidList::Tail()
{
	VoidCons* pCons = pHead;
	while ( pCons->pNext ) pCons = pCons->pNext;
	if ( ! pCons->IsValid ) pCons = PreviousValid( pCons );
	Take( pCons );
	return pCons;
}


VoidCons* VoidList::Next( VoidCons* pCons )
{
	VoidCons* pNext = NextValid( pCons->pNext );

	if ( pNext != null ) this->Take( pNext );
	Drop( pCons );

	return pNext;
}


VoidCons* VoidList::Previous( VoidCons* pCons )
{
	VoidCons* pPrevious = PreviousValid( pCons );

	if ( pPrevious != null ) Take( pPrevious );
	Drop( pCons );

	return pPrevious;
}


VoidCons* VoidList::Find( void* pObject )
{
	VoidCons* pCons = null;
	for ( pCons = Head(); pCons != null; pCons = Next( pCons ) )
	{
		if ( pCons->pObject == pObject ) break;
	}

	return pCons;
}


void VoidList::Take( VoidCons* pTake )
{
	pTake->Count++;
}


void VoidList::Drop( VoidCons* pDrop )
{
    if ( pDrop == null ) return;

	if ( ! pDrop->IsValid && pDrop->Count == 1 )
	{
		VoidCons* pNext = NextValid( pDrop->pNext );
		VoidCons* pPrevious = PreviousValid( pDrop );
		if ( pNext != null ) pNext->pPrevious = pPrevious;
		if ( pPrevious != null ) pPrevious->pNext = pNext;
		delete pDrop;
	}
	else
	{
		pDrop->Count--;
	}
}


VoidList::VoidList()
{
	pHead = new VoidCons;

	pHead->pNext = null;
	pHead->pPrevious = null;
	pHead->pObject = null;
	pHead->IsValid = true;
	pHead->Count = 0;

	pTail = pHead;
}


VoidList::~VoidList()
{
	for ( VoidCons* pNext, * pThis = pHead; pThis != null; pThis = pNext )
	{
		pNext = pThis->pNext;
		delete pThis;
	}
}


VoidCons* VoidList::NextValid( VoidCons* pCons )
{
	while ( pCons && ! pCons->IsValid ) pCons = pCons->pNext;
	return pCons;
}


VoidCons* VoidList::PreviousValid( VoidCons* pCons )
{
	if ( pCons != null ) pCons = pCons->pPrevious;
	while ( pCons != null && ! pCons->IsValid ) pCons = pCons->pPrevious;
	return pCons;
}

